## libssh2 0.18

=== nw/Makefile ===
include Makefile.netware

=== win32/Makefile ===
include Makefile.win32

## libssh2 1.2.6

=== debian/control ===
Source: libssh2
Section: libs
Priority: optional
Maintainer: Mikhail Gusarov <dottedmag@debian.org>
Build-Depends: debhelper (>= 7), autotools-dev, automake, libtool, libgcrypt11-dev, zlib1g-dev
Standards-Version: 3.8.4

Package: libssh2-1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SSH2 client-side library
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP sessions; port forwarding;
 password, key-based and keyboard-interactive authentication.
 .
 This package contains the runtime library.

Package: libssh2-1-dev
Conflicts: libssh2-0-dev
Replaces: libssh2-0-dev
Section: libdevel
Architecture: any
Depends: libssh2-1 (= ${binary:Version}), ${misc:Depends}
Description: SSH2 client-side library (development headers)
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP sessions; port forwarding;
 password, key-based and keyboard-interactive authentication.
 .
 This package contains the development files.

Package: libssh2-1-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libssh2-1 (= ${binary:Version}), libssh2-1-dev (= ${binary:Version}), ${misc:Depends}
Description: SSH2 client-side library (debug package)
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP sessions; port forwarding;
 password, key-based and keyboard-interactive authentication.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# Replaced by autoreconf
KEEP_FILES=config.sub \
	config.guess \
	configure \
	Makefile.in \
	docs/Makefile.in \
	example/Makefile.in \
	src/Makefile.in \
	tests/Makefile.in \
	install-sh \
	ltmain.sh \
	aclocal.m4 \
	m4/libtool.m4 \
	m4/ltversion.m4 \
	depcomp \
	missing \
	win32/libssh2.dsp \
	ChangeLog

clean:
	dh_testdir
	dh_testroot

	[ ! -f Makefile ] || $(MAKE) distclean

	for i in $(KEEP_FILES); do \
		if [ -f $$i.dist ]; then \
			mv -f $$i.dist $$i; \
		fi; \
	done

	dh_clean

config.status:
	dh_testdir

	for i in $(KEEP_FILES); do \
		if ! [ -f $$i.dist ]; then \
			mv -f $$i $$i.dist; \
		fi; \
	done

ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif

	autoreconf -fi -I m4

	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr \
		--with-libgcrypt

build: build-stamp
build-stamp: config.status
	dh_testdir
	$(MAKE)
	touch build-stamp

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installchangelogs NEWS
    # Do not install auxiliary files
	dh_installexamples -X .deps -X Makefile -X .gitignore
	dh_installman
	dh_install --sourcedir=debian/tmp
	dh_link
	dh_strip --dbg-package=libssh2-1-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## libssh2 1.2.8

=== debian/changelog ===
libssh2 (1.2.8-2ubuntu0.1) precise-security; urgency=medium

  * SECURITY UPDATE: Generated secrets too short during key exchange
    (LP: #1664812).
    - debian/patches/CVE-2016-0787.patch: convert bytes to bits in random
      number generation. Based on upstream patch.
    - CVE-2016-0787

 -- Brian Morton <rokclimb15@gmail.com>  Thu, 16 Feb 2017 16:15:00 -0500

libssh2 (1.2.8-2) unstable; urgency=low

  * Fix version in pkg-config file (Closes: #637670).

 -- Mikhail Gusarov <dottedmag@debian.org>  Sun, 14 Aug 2011 21:42:38 +0200

libssh2 (1.2.8-1) unstable; urgency=low

  * New upstream release.

 -- Mikhail Gusarov <dottedmag@debian.org>  Sat, 09 Apr 2011 16:20:20 +0200

libssh2 (1.2.7-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version, no changes needed.

 -- Mikhail Gusarov <dottedmag@debian.org>  Mon, 28 Mar 2011 21:03:51 +0200

libssh2 (1.2.6-1) unstable; urgency=low

  * New upstream release.
    - Update symbols file. libssh2_error and libssh2_kex_exchange symbols
      were unexported, being private.
  * Simplify package description (Closes: #580325).
  * Update Maintainer field to use my @debian.org address.
  * Convert debian/copyright to machine-readable format.

 -- Mikhail Gusarov <dottedmag@debian.org>  Thu, 10 Jun 2010 17:33:32 +0700

libssh2 (1.2.5-1) unstable; urgency=low

  * New upstream release.
    - Update symbols file.
  * Convert to source format 3.0 (quilt)
  * Bump Standards-Version to 3.8.4, no changes needed.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Thu, 01 Apr 2010 21:46:07 +0700

libssh2 (1.2.4-1) unstable; urgency=low

  * New upstream release.
    - Adjust list of files to stash before build and to restore later.
    - Update symbols file.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Sun, 28 Feb 2010 13:11:14 +0600

libssh2 (1.2.2-1) unstable; urgency=low
  
  * New upstream release.

  * Run autoreconf during build to update libtool/automake/autoconf
    generated files (Closes: #558523).
    - Expand list of files to stash before build and to restore after.

  * Remove disable_example_compilation.patch, example compilation does not
    hurt anyone.
    - Remove quilt from Build-Depends,
    - Stop call patch/unpatch in debian/rules,
    - Remove README.source.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Sun, 29 Nov 2009 18:45:58 +0600

libssh2 (1.2.1-2) unstable; urgency=low

  * Install libssh2.pc (Closes: #554437)

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Wed, 04 Nov 2009 23:48:29 +0600

libssh2 (1.2.1-1) unstable; urgency=low

  * debian/watch:
    - update to match changed upstream download location.
  * debian/rules:
    - adjust "keep files" list in order to produce clean .diff.gz
    - avoid installing .gitignore alongside the examples
    - stylistic fixes
  * debian/control:
    - bump Standards-Version, no changes required.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Mon, 28 Sep 2009 19:10:36 +0700

libssh2 (1.2-1) unstable; urgency=low

  * New upstream release.
    - updated debian/libssh2-1.symbols.
  * debian/rules: config.sub, config.guess, ChangeLog and
    win32/libssh2.dsp from tarball are preserved, due to being deleted by
    `make distclean'.
  * Standards-Version updated to 3.8.2, no changes required.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Thu, 13 Aug 2009 02:28:57 +0700

libssh2 (1.1-1) unstable; urgency=low

  * New upstream release.
    - Dropped unexport-private-symbols.patch, applied upstream.
    - Dropped fix_manpage.patch, applied upstream.
    - Lots of private symbols were un-exported, adjusting
      libssh2-1.symbols
  * Updating Standards-Version to 3.8.1, no changes required.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Thu, 02 Apr 2009 16:20:42 +0700

libssh2 (1.0-1) unstable; urgency=low

  * New upstream release (Closes: #514225).
  * Replaced fix_manpage.patch with new set of manpages' fixes.
  * debian/patches/disable_example_compilation.patch:
    - added description, as suggested by Lintian,
    - refreshed.
  * debian/patches/unexport-private-symbols.patch:
    - new patch, disabling export of _libssh2_* private symbols.
  * debian/libssh2-1.symbols:
    - added symbols file.
  * debian/control:
    - removed duplicate Section: libs from binary package,
    - bumped Standards-Version to 3.8.0:
      + debian/README.source added.
  * debian/rules:
    - clean target now unpatches the source,
    - no longer reconfigures package twice: fixed quilt patch target,
    - simplified configure target,
    - deprecated dh_clean -k replaced with dh_prep.
  * debhelper compat bumped to 7.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Tue, 17 Feb 2009 22:50:14 +0600

libssh2 (0.18-1) unstable; urgency=low

  * New upstream release
    - Removed 'CVS directories in tarball' lintian override.
  
  - Added patch fixing the syntactic errors in manpages.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Sun, 11 Nov 2007 17:16:34 +0600

libssh2 (0.17-1) unstable; urgency=low

  * New upstream release (Closes: #409362, #430569):
    * ABI change: soname changed (adding Conflicts and Replaces to new
      -dev package)
    * installing more documentation.
    * added lintian override: CVS directory accidentally went in release
      tarball.
  * Build using libgcrypt, not OpenSSL (Closes: #409362).
  * Quilt introduced to manage patches:
    * Added patch disabling compilation of example.
  * Watch file added.
  * ${Source-Version} changed to ${binary:Version}: makes lintian happy
    and allows binNMUs.

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Wed, 04 Jul 2007 15:21:46 +0700

libssh2 (0.14+20070102-1) unstable; urgency=low

  * Initial release (Closes: #403446).

 -- Mikhail Gusarov <dottedmag@dottedmag.net>  Tue,  2 Jan 2007 03:17:15 +0600

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: libssh2
 Section: libs
 Priority: optional
-Maintainer: Mikhail Gusarov <dottedmag@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mikhail Gusarov <dottedmag@debian.org>
 Build-Depends: debhelper (>= 7), autotools-dev, automake, libtool, libgcrypt11-dev, zlib1g-dev
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 
 Package: libssh2-1
 Architecture: any

## libssh2 1.4.0

=== debian/changelog ===
libssh2 (1.4.0-1) unstable; urgency=low

  * New upstream release.
    - Drop debian/patches/fix-version-in-pc.patch taken from git.
    - Drop debian/patches/mang-wrong-nf-macro.patch, applied upstream.
    - Update libssh2-1.symbols for new upstream release.
    - Add debian/patches/undefined-libssh-error.patch, necessary to
      facilitate compilation with GnuTLS.
  * Drop Conflicts/Replaces for packages no longer in archive.
  * Use dh(7) for packaging.
  * Use dh-autoreconf instead of manually stashing changed files and
    moving them back.
  * Do not run test 'mansyntax.sh', it requires specific locale to be
    available, and in general is a duplicate of lintian check.
  * Update debian/copyright to version 1.0 of machine-parseable format.
  * Enable multiarch, based on patch by Johannes Cloos (Closes: #663751).
  * Bump Standards-Version, no changes needed.

 -- Mikhail Gusarov <dottedmag@debian.org>  Mon, 19 Mar 2012 17:53:21 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: libssh2
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mikhail Gusarov <dottedmag@debian.org>
-Build-Depends: debhelper (>= 7), autotools-dev, automake, libtool, libgcrypt11-dev, zlib1g-dev
-Standards-Version: 3.9.1
+Maintainer: Mikhail Gusarov <dottedmag@debian.org>
+Build-Depends: debhelper (>= 9), dh-autoreconf, libgcrypt11-dev, zlib1g-dev, chrpath
+Standards-Version: 3.9.3
 
 Package: libssh2-1
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: SSH2 client-side library
  libssh2 is a client-side C library implementing the SSH2 protocol.
  It supports regular terminal, SCP and SFTP sessions; port forwarding;
@@ -17,8 +18,6 @@
  This package contains the runtime library.
 
 Package: libssh2-1-dev
-Conflicts: libssh2-0-dev
-Replaces: libssh2-0-dev
 Section: libdevel
 Architecture: any
 Depends: libssh2-1 (= ${binary:Version}), ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CONFIGURE_EXTRA_FLAGS += --with-libgcrypt
CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
CONFIGURE_EXTRA_FLAGS += --disable-rpath

%:
	dh $@ --parallel --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_EXTRA_FLAGS)

override_dh_installexamples:
	dh_installexamples -a -X .deps -X Makefile -X .gitignore

#
# mansyntax.sh test duplicates functionality of debhelper and requires presence
# of en_US.utf8 locale. Ensure it is not run by providing fake man(1) tool.
#
override_dh_auto_test:
	PATH=$(CURDIR)/debian:$$PATH dh_auto_test -a

override_dh_strip:
	dh_strip -a --dbg-package=libssh2-1-dbg

## libssh2 1.4.2

=== debian/changelog ===
libssh2 (1.4.2-1.1+deb7u8) wheezy-security; urgency=high

  * Non-maintainer upload by the ELTS team.
  * Fix CVE-2019-17498:
    In libssh2, the SSH_MSG_DISCONNECT logic in
    packet.c has an integer overflow in a bounds check, enabling an attacker to
    specify an arbitrary (out-of-bounds) offset for a subsequent memory read. A
    crafted SSH server may be able to disclose sensitive information or cause a
    denial of service condition on the client system when a user connects to
    the server.

 -- Markus Koschany <apo@debian.org>  Mon, 04 Nov 2019 20:02:57 +0100

libssh2 (1.4.2-1.1+deb7u7) wheezy-security; urgency=medium

  * Non-maintainer upload by the ELTS team.
  * debian/rules: (Now really!) Drop --enable-debug configure option (again).
    It was forgotten to be removed before uploading +deb7u5.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 30 Jul 2019 20:40:09 +0200

libssh2 (1.4.2-1.1+deb7u6) wheezy-security; urgency=medium

  * Non-maintainer upload by the ELTS team.
  * debian/rules: Drop --enable-debug configure option (again).
    It was forgotten to be removed before uploading +deb7u5.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 30 Jul 2019 20:35:24 +0200

libssh2 (1.4.2-1.1+deb7u5) wheezy-security; urgency=medium

  * Non-maintainer upload by the ELTS team.
  * CVE-2019-3859:
    - CVE-2019-3859 (+ CVE-2019-13115): Correctly check key_state data length
      in kex_method_diffie_hellman_group_exchange_sha1_key_exchange() in kex.c.
      Avoid various signedness flaws introduced by the initial fix(es) around
      CVE-2019-3859 (regression CVE registered as CVE-2019-13115).
    - Add CVE-2019-3859-4_channel-c.patch and CVE-2019-3859-5_userauth-c.patch.
      Derived by manually comparing upstream security fix commit
      dc109a7f518757741590bb993c0c8412928ccec2 against what we had in
      Debian jessie LTS's versions of libssh2, so far.
    - This completes a series of fixes unfortunately only partially provided
      in earlier security uploads of libssh2 to Debian jessie LTS.
      Due to non-optimal CVE documentation and the manifold of upstream security
      changes before libssh2 1.9, it hasn't been easy to identify all
      necessary changes to fix the recent CVEs (2019-3855 - 2019-3863).
      Furthermore, for a non-upstream dev it has neither been easy to identify
      which upstream fix was for which CVE.
  * Add additional-bounds-checks-in-diffie_hellman_sha1.patch. Additional
    bound checks in diffie_hellman_sha1.
  * CVE-2019-3860:
    - Additional bounds checking in sftp.c.
    - Use LIBSSH2_ERROR_BUFFER_TOO_SMALL instead of
      LIBSSH2_ERROR_OUT_OF_BOUNDARY in sftp.c

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 25 Jul 2019 00:29:58 +0200

libssh2 (1.4.2-1.1+deb7u4) wheezy-security; urgency=high

  * Non-maintainer upload by the ELTS Team.
  * CVE-2019-3859: Regression fix. Fix user authentication.
    See https://github.com/libssh2/libssh2/pull/327 for details.
    Thanks to Salvatore Bonaccorso for noticing this.

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 06 Apr 2019 19:43:02 +0100

libssh2 (1.4.2-1.1+deb7u3) wheezy-security; urgency=high

  * Non-maintainer upload by the ELTS Team.
  * CVE-2019-3855: Do packet length bounds check in _libssh2_transport_read()
    (src/transport.c).
  * CVE-2019-3856, CVE-2019-3863: Bounds checks in
    userauth_keyboard_interactive() (src/userauth.c). 
  * CVE-2019-3857: Fix possible out zero byte/incorrect bounds allocation
    in _libssh2_packet_add() (src/packet.c).
  * CVE-2019-3858: Prevent zero-byte allocation in sftp_packet_read()
    which could lead to an out-of-bounds read.
  * CVE-2019-3859: Response length check in session_startup()
    (src/transport.c), and bounds checks in various functions
    (src/kex.c, src/channel.c).
  * CVE-2019-3860: Add a required_size parameter to sftp_packet_require
    et. al. to require callers of these functions to handle packets that
    are too short.
  * CVE-2019-3861: Sanitize padding_length - _libssh2_transport_read().
    This prevents an underflow resulting in a potential out-of-bounds read
    if a server sends a too-large padding_length, possibly with malicious
    intent.
  * CVE-2019-3862: Additional length checks to prevent out-of-bounds
    reads and writes in _libssh2_packet_add().
 
 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 27 Mar 2019 19:03:02 +0100

libssh2 (1.4.2-1.1+deb7u2) wheezy-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * CVE-2016-0787: Truncated Difffie-Hellman secret length

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 18 Feb 2016 20:29:28 +0100

libssh2 (1.4.2-1.1+deb7u1) wheezy-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add CVE-2015-1782.patch.
    CVE-2015-1782: Using SSH_MSG_KEXINIT data unbounded.

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 06 Mar 2015 18:46:50 +0100

libssh2 (1.4.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Added patch to fix pkg-config/libgcrypt dependency (Closes: #675785).
  * Install upstream ChangeLog (Closes: #675782).
  * debian/control:
    + libssh2-1-dev to depend on libgcrypt11-dev.
    + added Homepage field.

 -- Dmitry Smirnov <onlyjob@member.fsf.org>  Sat, 04 Aug 2012 19:13:21 +1000

libssh2 (1.4.2-1) unstable; urgency=low

  * New upstream release.

 -- Mikhail Gusarov <dottedmag@debian.org>  Mon, 28 May 2012 17:41:48 +0200

libssh2 (1.4.1-1) unstable; urgency=low

  * New upstream release.
    - Drop debian/patches/undefined-libssh-error.patch, upstream.

 -- Mikhail Gusarov <dottedmag@debian.org>  Sun, 08 Apr 2012 16:39:12 +0200

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 CONFIGURE_EXTRA_FLAGS += --with-libgcrypt
 CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 CONFIGURE_EXTRA_FLAGS += --disable-rpath
+#CONFIGURE_EXTRA_FLAGS += --enable-debug
 
 %:
 	dh $@ --parallel --with autoreconf
@@ -15,6 +16,9 @@
 override_dh_installexamples:
 	dh_installexamples -a -X .deps -X Makefile -X .gitignore
 
+override_dh_installchangelogs:
+	dh_installchangelogs NEWS
+
 #
 # mansyntax.sh test duplicates functionality of debhelper and requires presence
 # of en_US.utf8 locale. Ensure it is not run by providing fake man(1) tool.

## libssh2 1.4.3

=== debian/changelog ===
libssh2 (1.4.3-2) unstable; urgency=medium

  * Make package multi-arch-aware (Closes: #731310).
  * Bump Standards-Version, no changes required.

 -- Mikhail Gusarov <dottedmag@debian.org>  Wed, 04 Dec 2013 21:29:00 +0100

libssh2 (1.4.3-1) unstable; urgency=low

  * New upstream release.
    - Drop debian/patches/with-gcrypt.patch, applied upstream.
  * Incorporate 1.4.2-1.1 NMU by Dmitry. Thanks!

 -- Mikhail Gusarov <dottedmag@debian.org>  Tue, 21 May 2013 12:09:00 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Mikhail Gusarov <dottedmag@debian.org>
 Build-Depends: debhelper (>= 9), dh-autoreconf, libgcrypt11-dev, zlib1g-dev, chrpath
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
+Homepage: http://libssh2.org/
 
 Package: libssh2-1
 Architecture: any
@@ -20,7 +21,8 @@
 Package: libssh2-1-dev
 Section: libdevel
 Architecture: any
-Depends: libssh2-1 (= ${binary:Version}), ${misc:Depends}
+Depends: libssh2-1 (= ${binary:Version}), ${misc:Depends}, libgcrypt11-dev
+Multi-Arch: same
 Description: SSH2 client-side library (development headers)
  libssh2 is a client-side C library implementing the SSH2 protocol.
  It supports regular terminal, SCP and SFTP sessions; port forwarding;
@@ -33,6 +35,7 @@
 Priority: extra
 Architecture: any
 Depends: libssh2-1 (= ${binary:Version}), libssh2-1-dev (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
 Description: SSH2 client-side library (debug package)
  libssh2 is a client-side C library implementing the SSH2 protocol.
  It supports regular terminal, SCP and SFTP sessions; port forwarding;

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,6 @@
 CONFIGURE_EXTRA_FLAGS += --with-libgcrypt
 CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 CONFIGURE_EXTRA_FLAGS += --disable-rpath
-#CONFIGURE_EXTRA_FLAGS += --enable-debug
 
 %:
 	dh $@ --parallel --with autoreconf

=== debian/watch ===
version=3
http://libssh2.org/download/libssh2-(.+)\.tar\.gz

## libssh2 1.5.0

=== debian/changelog ===
libssh2 (1.5.0-2ubuntu0.1) xenial-security; urgency=medium

  * SECURITY UPDATE: Generated secrets too short during key exchange
    (LP: #1664812).
    - debian/patches/CVE-2016-0787.patch: convert bytes to bits in random
      number generation. Based on upstream patch.
    - CVE-2016-0787

 -- Brian Morton <rokclimb15@gmail.com>  Tue, 14 Feb 2017 23:33:00 -0500

libssh2 (1.5.0-2) unstable; urgency=medium

  * Fix ABI by linking to gcrypt again (Closes: #781507)

 -- Mikhail Gusarov <dottedmag@debian.org>  Mon, 30 Mar 2015 11:43:48 +0200

libssh2 (1.5.0-1) unstable; urgency=low

  * New upstream release.
    - Drop 0003-CVE-2015-1782.patch, included upstream.
  * Acknowledge 1.4.3-4.1 NMU. Thanks, Salvatore!

 -- Mikhail Gusarov <dottedmag@debian.org>  Thu, 19 Mar 2015 07:39:43 +0100

libssh2 (1.4.3-4.1) unstable; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add 0003-CVE-2015-1782.patch.
    CVE-2015-1782: Using SSH_MSG_KEXINIT data unbounded. (Closes: #780249)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 11 Mar 2015 12:08:30 +0100

libssh2 (1.4.3-4) unstable; urgency=low

  * Update description to mention SFTPv5 support
    (Closes: #671199).
  * Add -lgpg-error to .pc file to fix static linking against libgcrypt
    (Closes: #760359).

 -- Mikhail Gusarov <dottedmag@debian.org>  Wed, 03 Sep 2014 15:49:23 +0200

libssh2 (1.4.3-3) unstable; urgency=low

  * Do not expose private libraries nor link flags to users of libssh2
    (Closes: #747417).
  * Rebuild with libgcrypt20 (Closes: #744829).
  * Fix typos in manpages.
  * Bump Standards-Version, no changes required.

 -- Mikhail Gusarov <dottedmag@debian.org>  Mon, 19 May 2014 10:23:27 +0200

=== debian/control ===
Source: libssh2
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mikhail Gusarov <dottedmag@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf, libgcrypt20-dev, zlib1g-dev, chrpath
Standards-Version: 3.9.6
Homepage: http://libssh2.org/

Package: libssh2-1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: SSH2 client-side library
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP (v1-v5) sessions;
 port forwarding, X11 forwarding; password, key-based and
 keyboard-interactive authentication.
 .
 This package contains the runtime library.

Package: libssh2-1-dev
Section: libdevel
Architecture: any
Depends: libssh2-1 (= ${binary:Version}), ${misc:Depends}, libgcrypt20-dev
Multi-Arch: same
Description: SSH2 client-side library (development headers)
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP (v1-v5) sessions;
 port forwarding, X11 forwarding; password, key-based and
 keyboard-interactive authentication.
 .
 This package contains the development files.

Package: libssh2-1-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libssh2-1 (= ${binary:Version}), libssh2-1-dev (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: SSH2 client-side library (debug package)
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP (v1-v5) sessions;
 port forwarding, X11 forwarding; password, key-based and
 keyboard-interactive authentication.
 .
 This package contains the debugging symbols.

## libssh2 1.7.0

=== debian/changelog ===
libssh2 (1.7.0-1ubuntu1) zesty; urgency=medium

  * SECURITY UPDATE: Generated secrets too short during key exchange
    (LP: #1664812).
    - debian/patches/CVE-2016-0787.patch: convert bytes to bits in random
      number generation. Based on upstream patch.
    - CVE-2016-0787

 -- Brian Morton <rokclimb15@gmail.com>  Tue, 14 Feb 2017 22:51:13 -0500

libssh2 (1.7.0-1) unstable; urgency=low

  * New upstream release(Closes: #825097).
    - Refresh patches.
  * Bump Standards-Version, no changes required.

 -- Mikhail Gusarov <dottedmag@debian.org>  Fri, 22 Jul 2016 09:05:27 +0200

## libssh2 1.8.0

=== debian/changelog ===
libssh2 (1.8.0-1ubuntu0.1) bionic-security; urgency=medium

  * SECURITY UPDATE: out of bounds memory access
    - debian/patches/CVE-2020-22218.patch: adds check for uninitialized
      variable total_num in _libssh2_transport_read of src/transport.c.
    - CVE-2020-22218

 -- Ian Constantin <ian.constantin@canonical.com>  Thu, 14 Sep 2023 12:01:35 +0300

libssh2 (1.8.0-1) unstable; urgency=low

  * New upstream release.
    - Refresh 0001-Add-lgpg-error-to-.pc-to-facilitate-static-linking.patch
    - Refresh 0001-Do-not-expose-private-libraries-nor-link-flags-to-us.patch
    - Take ced924b78a40126606797ef57a74066eb3b4b83f.patch from upstream
  * Do not build against OpenSSL even if libssl-dev is installed
    (Closes: #857793).

 -- Mikhail Gusarov <dottedmag@debian.org>  Thu, 16 Mar 2017 00:56:58 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Mikhail Gusarov <dottedmag@debian.org>
 Build-Depends: debhelper (>= 9), dh-autoreconf, libgcrypt20-dev, zlib1g-dev, chrpath
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://libssh2.org/
 
 Package: libssh2-1

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
-CONFIGURE_EXTRA_FLAGS += --with-libgcrypt
+CONFIGURE_EXTRA_FLAGS += --with-libgcrypt --without-openssl
 CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 CONFIGURE_EXTRA_FLAGS += --disable-rpath

## libssh2 1.8.0.1

=== debian/changelog ===
libssh2 (1.8.0.1-2.1+dde) unstable; urgency=low

  * ['Autobuild release-candidate: 9ec70a90b9209e2f21454a5a05ddceb5cdd38246']

 -- shuttle <shuttle@deepin.com>  Thu, 30 Jul 2020 13:31:03 +0000

## libssh2 1.9.0

=== debian/changelog ===
libssh2 (1.9.0-3) unstable; urgency=medium

  * d/rules: Build with openssl instead of libgcrypt (Closes: #668271)
  * d/tests: Build with openssl instead of libgcrypt

 -- Nicolas Mora <babelouest@debian.org>  Sat, 27 Mar 2021 08:21:05 -0400

libssh2 (1.9.0-2) unstable; urgency=medium

  * d/control: Fix VCS URIs
  * d/control: add zlib1g-dev as dependency for libssh2-1-dev

 -- Nicolas Mora <babelouest@debian.org>  Mon, 14 Dec 2020 10:02:16 -0500

libssh2 (1.9.0-1) unstable; urgency=low

  [ Mikhail Gusarov ]
  * New upstream release (1.9.0) (Closes: #887976 #959881)
    - Drop patches applied upstream:
      - ced924b78a40126606797ef57a74066eb3b4b83f.patch
      - CVE-2019-3855.patch
      - CVE-2019-3856.patch
      - CVE-2019-3857.patch
      - CVE-2019-3858.patch
      - CVE-2019-3859.patch
      - CVE-2019-3860.patch
      - CVE-2019-3861.patch
      - CVE-2019-3862.patch
      - CVE-2019-3863.patch
      - Fixed-misapplied-patch-327.patch
      - moved-MAX-size-declarations-330.patch
    - Fixes CVE-2019-13115 (Closes: #932329).
  * Acknowledge NMU 1.8.0-2.1, thanks to carnil@.
  * Add debian/patches/CVE-2019-17498.patch, fixing CVE-2019-17498
    (Closes: #943562).
  * debian/copyright: Update upstream link to be https (Closes: #923088)

  [ Nicolas Mora ]
  * New maintainer (Closes: #975617)
  * d/control: Update Standards-Version to 4.5.1
  * d/control: Uses debhelper-compat to version 13
  * d/control: Adds Rules-Requires-Root: no
  * d/watch : upgrade version to 4 (no changes)
  * d/upstream: Add metadata file
  * d/tests: add autopkgtests
  * d/control: Add VCS URIs

 -- Nicolas Mora <babelouest@debian.org>  Sat, 05 Dec 2020 16:15:24 -0500

libssh2 (1.8.0-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Possible integer overflow in transport read allows out-of-bounds write
    (CVE-2019-3855) (Closes: #924965)
  * Possible integer overflow in keyboard interactive handling allows
    out-of-bounds write (CVE-2019-3856) (Closes: #924965)
  * Possible integer overflow leading to zero-byte allocation and
    out-of-bounds write (CVE-2019-3857) (Closes: #924965)
  * Possible zero-byte allocation leading to an out-of-bounds read
    (CVE-2019-3858) (Closes: #924965)
  * Out-of-bounds reads with specially crafted payloads due to unchecked use
    of _libssh2_packet_require and _libssh2_packet_requirev (CVE-2019-3859)
    (Closes: #924965)
  * Out-of-bounds reads with specially crafted SFTP packets (CVE-2019-3860)
    (Closes: #924965)
  * Out-of-bounds reads with specially crafted SSH packets (CVE-2019-3861)
    (Closes: #924965)
  * Out-of-bounds memory comparison (CVE-2019-3862) (Closes: #924965)
  * Integer overflow in user authenicate keyboard interactive allows
    out-of-bounds writes (CVE-2019-3863) (Closes: #924965)
  * Fixed misapplied patch for user auth.
  * moved MAX size declarations

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 31 Mar 2019 16:06:20 +0200

libssh2 (1.8.0-2) unstable; urgency=low

  * Add missing zlib1g-dev dependency (Closes: #900558).
  * Remove manual -dbg package and corresponding override in d/rules.
  * Update Homepage, copyright and tarball download URL to use https.
  * Clean spurious EOL whitespace from d/changelog.
  * Add signature check to debian/watch.
  * Update debhelper compatibility (and dependency).
  * Remove no longer needed explicit dh --parallel flag
  * Enable full hardening mode.
  * Update packaging copyright years.
  * Bump Standards-Version.

 -- Mikhail Gusarov <dottedmag@debian.org>  Sat, 23 Jun 2018 21:45:38 +0200

=== debian/control ===
Source: libssh2
Section: libs
Priority: optional
Maintainer: Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , libssl-dev
             , zlib1g-dev
             , chrpath
Standards-Version: 4.5.1
Homepage: https://libssh2.org/
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/libssh2
Vcs-Git: https://salsa.debian.org/debian/libssh2.git

Package: libssh2-1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: SSH2 client-side library
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP (v1-v5) sessions;
 port forwarding, X11 forwarding; password, key-based and
 keyboard-interactive authentication.
 .
 This package contains the runtime library.

Package: libssh2-1-dev
Section: libdevel
Architecture: any
Depends: libssh2-1 (= ${binary:Version}), ${misc:Depends}
       , libssl-dev
       , zlib1g-dev
Multi-Arch: same
Description: SSH2 client-side library (development headers)
 libssh2 is a client-side C library implementing the SSH2 protocol.
 It supports regular terminal, SCP and SFTP (v1-v5) sessions;
 port forwarding, X11 forwarding; password, key-based and
 keyboard-interactive authentication.
 .
 This package contains the development files.

## libssh2 1.10.0

=== CMakeLists.txt ===
# Copyright (c) 2014, 2015  Alexander Lamaison <alexander.lamaison@gmail.com>
#
# Redistribution and use in source and binary forms,
# with or without modification, are permitted provided
# that the following conditions are met:
#
#   Redistributions of source code must retain the above
#   copyright notice, this list of conditions and the
#   following disclaimer.
#
#   Redistributions in binary form must reproduce the above
#   copyright notice, this list of conditions and the following
#   disclaimer in the documentation and/or other materials
#   provided with the distribution.
#
#   Neither the name of the copyright holder nor the names
#   of any other contributors may be used to endorse or
#   promote products derived from this software without
#   specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
# OF SUCH DAMAGE.

cmake_minimum_required(VERSION 2.8.11)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

project(libssh2 C)
set(PROJECT_URL "https://www.libssh2.org/")
set(PROJECT_DESCRIPTION "The SSH library")

if (CMAKE_VERSION VERSION_LESS "3.1")
  if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
    set (CMAKE_C_FLAGS "--std=gnu90 ${CMAKE_C_FLAGS}")
  endif()
else()
  set (CMAKE_C_STANDARD 90)
endif()

option(BUILD_SHARED_LIBS "Build Shared Libraries" OFF)

# Parse version

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/include/libssh2.h _HEADER_CONTENTS)
string(
  REGEX REPLACE ".*#define LIBSSH2_VERSION[ \t]+\"([^\"]+)\".*" "\\1"
  LIBSSH2_VERSION "${_HEADER_CONTENTS}")
string(
  REGEX REPLACE ".*#define LIBSSH2_VERSION_MAJOR[ \t]+([0-9]+).*" "\\1"
  LIBSSH2_VERSION_MAJOR "${_HEADER_CONTENTS}")
string(
  REGEX REPLACE ".*#define LIBSSH2_VERSION_MINOR[ \t]+([0-9]+).*" "\\1"
  LIBSSH2_VERSION_MINOR "${_HEADER_CONTENTS}")
string(
  REGEX REPLACE ".*#define LIBSSH2_VERSION_PATCH[ \t]+([0-9]+).*" "\\1"
  LIBSSH2_VERSION_PATCH "${_HEADER_CONTENTS}")

if(NOT LIBSSH2_VERSION OR
   NOT LIBSSH2_VERSION_MAJOR MATCHES "^[0-9]+$" OR
   NOT LIBSSH2_VERSION_MINOR MATCHES "^[0-9]+$" OR
   NOT LIBSSH2_VERSION_PATCH MATCHES "^[0-9]+$")
  message(
    FATAL_ERROR
    "Unable to parse version from"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/libssh2.h")
endif()

include(GNUInstallDirs)
install(
  FILES docs/AUTHORS COPYING docs/HACKING README RELEASE-NOTES NEWS
  DESTINATION ${CMAKE_INSTALL_DOCDIR})

include(max_warnings)
include(FeatureSummary)

add_subdirectory(src)

option(BUILD_EXAMPLES "Build libssh2 examples" ON)
if(BUILD_EXAMPLES)
  add_subdirectory(example)
endif()

option(BUILD_TESTING "Build libssh2 test suite" ON)
if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()

option(LINT "Check style while building" OFF)
if(LINT)
  add_custom_target(lint ALL
    ./ci/checksrc.sh
    WORKING_DIRECTORY ${libssh2_SOURCE_DIR})
  add_dependencies(libssh2 lint)
endif()

add_subdirectory(docs)

feature_summary(WHAT ALL)

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBSSH2_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBSSH2_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBSSH2_VERSION_PATCH})
set(CPACK_PACKAGE_VERSION ${LIBSSH2_VERSION})
include(CPack)

=== tests/CMakeLists.txt ===
# Copyright (c) 2014-2016 Alexander Lamaison <alexander.lamaison@gmail.com>
#
# Redistribution and use in source and binary forms,
# with or without modification, are permitted provided
# that the following conditions are met:
#
#   Redistributions of source code must retain the above
#   copyright notice, this list of conditions and the
#   following disclaimer.
#
#   Redistributions in binary form must reproduce the above
#   copyright notice, this list of conditions and the following
#   disclaimer in the documentation and/or other materials
#   provided with the distribution.
#
#   Neither the name of the copyright holder nor the names
#   of any other contributors may be used to endorse or
#   promote products derived from this software without
#   specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
# OF SUCH DAMAGE.

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(BundleUtilities)
include(CopyRuntimeDependencies)
include(SocketLibraries)

## Platform checks
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_files(arpa/inet.h HAVE_ARPA_INET_H)
check_include_files(windows.h HAVE_WINDOWS_H)
check_include_files(winsock2.h HAVE_WINSOCK2_H)
check_include_files(netinet/in.h HAVE_NETINET_IN_H)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/libssh2_config_cmake.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/libssh2_config.h")
append_needed_socket_libraries(LIBRARIES)

## Cryptography backend choice

set(CRYPTO_BACKEND
  ""
  CACHE
  STRING
  "The backend to use for cryptography: OpenSSL, Libgcrypt or WinCNG, mbedTLS
or empty to try any available")

# If the crypto backend was given, rather than searching for the first
# we are able to find, the find_package commands must abort configuration
# and report to the user.
if(CRYPTO_BACKEND)
  set(SPECIFIC_CRYPTO_REQUIREMENT REQUIRED)
endif()

if(CRYPTO_BACKEND STREQUAL "OpenSSL" OR NOT CRYPTO_BACKEND)

  find_package(OpenSSL ${SPECIFIC_CRYPTO_REQUIREMENT})

  if(OPENSSL_FOUND)
    set(CRYPTO_BACKEND "OpenSSL")
  endif()
endif()

if(CRYPTO_BACKEND STREQUAL "Libgcrypt" OR NOT CRYPTO_BACKEND)

  find_package(Libgcrypt ${SPECIFIC_CRYPTO_REQUIREMENT})

  if(LIBGCRYPT_FOUND)
    set(CRYPTO_BACKEND "Libgcrypt")
  endif()
endif()

if(CRYPTO_BACKEND STREQUAL "WinCNG" OR NOT CRYPTO_BACKEND)

  # The check actually compiles the header.  This requires windows.h.
  check_include_files("windows.h;bcrypt.h" HAVE_BCRYPT_H)

  if(HAVE_BCRYPT_H)
    set(CRYPTO_BACKEND "WinCNG")
  endif()
endif()

if(CRYPTO_BACKEND STREQUAL "mbedTLS" OR NOT CRYPTO_BACKEND)

  find_package(mbedTLS ${SPECIFIC_CRYPTO_REQUIREMENT})

  if(MBEDTLS_FOUND)
    set(CRYPTO_BACKEND "mbedTLS")
  endif()
endif()

set(TESTS
  hostkey
  hostkey_hash
  password_auth_succeeds_with_correct_credentials
  password_auth_fails_with_wrong_password
  password_auth_fails_with_wrong_username
  public_key_auth_fails_with_wrong_key
  public_key_auth_succeeds_with_correct_rsa_key
  public_key_auth_succeeds_with_correct_encrypted_rsa_key
  keyboard_interactive_auth_fails_with_wrong_response
  keyboard_interactive_auth_succeeds_with_correct_response
  agent_forward_succeeds
  )

if(CRYPTO_BACKEND STREQUAL "OpenSSL")
    list(APPEND TESTS
      public_key_auth_succeeds_with_correct_rsa_openssh_key
    )
    if(OPENSSL_VERSION VERSION_GREATER "1.1.0")
      list(APPEND TESTS
        public_key_auth_succeeds_with_correct_ed25519_key
        public_key_auth_succeeds_with_correct_encrypted_ed25519_key
        public_key_auth_succeeds_with_correct_ed25519_key_from_mem
        public_key_auth_succeeds_with_correct_ecdsa_key
        public_key_auth_succeeds_with_correct_signed_ecdsa_key
       )
    endif()
endif()

if(NOT CRYPTO_BACKEND STREQUAL "mbedTLS")
  list(APPEND TESTS
    public_key_auth_succeeds_with_correct_dsa_key
    )
endif()

add_library(openssh_fixture STATIC openssh_fixture.h openssh_fixture.c)
target_link_libraries(openssh_fixture ${LIBRARIES})
target_include_directories(openssh_fixture PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

add_library(session_fixture STATIC session_fixture.h session_fixture.c)
target_link_libraries(session_fixture ${LIBRARIES} openssh_fixture libssh2)
target_include_directories(session_fixture PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

add_library(runner STATIC runner.c)
target_link_libraries(runner session_fixture)
target_include_directories(runner PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

foreach(test ${TESTS})
  add_executable(test_${test} test_${test}.c)
  target_link_libraries(test_${test} libssh2 runner ${LIBRARIES})
  target_include_directories(test_${test} PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")
  list(APPEND TEST_TARGETS test_${test})
  add_definitions(-DFIXTURE_WORKDIR="${CMAKE_CURRENT_SOURCE_DIR}")

  add_test(
    NAME test_${test} COMMAND $<TARGET_FILE:test_${test}>
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endforeach()

add_target_to_copy_dependencies(
  TARGET copy_test_dependencies
  DEPENDENCIES ${RUNTIME_DEPENDENCIES}
  BEFORE_TARGETS ${TEST_TARGETS})


# TODO convert mansyntax.sh into CMake script.
# XXX Just because we can find all three programs, doesn't mean sh can
# find man and grep
find_program(SH_EXECUTABLE sh)
find_program(MAN_EXECUTABLE man)
find_program(GREP_EXECUTABLE grep)
mark_as_advanced(SH_EXECUTABLE MAN_EXECUTABLE GREP_EXECUTABLE)
if(SH_EXECUTABLE AND MAN_EXECUTABLE AND GREP_EXECUTABLE)
  set(cmd "srcdir=${CMAKE_CURRENT_SOURCE_DIR}")
  set(cmd "${cmd} ${CMAKE_CURRENT_SOURCE_DIR}/mansyntax.sh")
  add_test(mansyntax ${SH_EXECUTABLE} -c "${cmd}")
endif()

=== debian/changelog ===
libssh2 (1.10.0-3) unstable; urgency=medium

  * d/patches: Fix ssh2.sh test (Closes: #1006379)
  * d/control: Add openssh-server in Build-Depends
  * d/tests/control: Add openssh-server in Depends
  * d/copyright: Update copyright years

 -- Nicolas Mora <babelouest@debian.org>  Tue, 01 Mar 2022 19:23:12 -0500

libssh2 (1.10.0-2) unstable; urgency=medium

  * Upload to unstable
  * d/control: upgrade standards version to 4.6.0

 -- Nicolas Mora <babelouest@debian.org>  Sat, 25 Sep 2021 08:43:37 -0400

libssh2 (1.10.0-1) experimental; urgency=medium

  * New upstream release
  * d/patches: remove CVE-2019-17498.patch
  * d/libssh2-1.symbols: add new symbol

 -- Nicolas Mora <babelouest@debian.org>  Sun, 29 Aug 2021 17:21:29 -0400

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
              , libssl-dev
              , zlib1g-dev
              , chrpath
-Standards-Version: 4.5.1
+             , openssh-server
+Standards-Version: 4.6.0
 Homepage: https://libssh2.org/
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libssh2

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# openssl license issue has been fixed: #668271, #924937
#CONFIGURE_EXTRA_FLAGS += --with-libgcrypt --without-openssl
CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
CONFIGURE_EXTRA_FLAGS += --disable-rpath

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_EXTRA_FLAGS)

override_dh_installexamples:
	dh_installexamples -a -X .deps -X Makefile -X .gitignore

override_dh_installchangelogs:
	dh_installchangelogs NEWS

#
# mansyntax.sh test duplicates functionality of debhelper and requires presence
# of en_US.utf8 locale. Ensure it is not run by providing a fake man(1) tool.
#
override_dh_auto_test:
	PATH=$(CURDIR)/debian:$$PATH dh_auto_test -a

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, autoconf, libssl-dev, zlib1g-dev, chrpath, openssh-server

=== debian/watch ===
version=4
https://www.libssh2.org/download/libssh2-(.+)\.tar\.gz
pgpmode=auto
